Subject: Cache key history

From: Mark Nottingham <[email-masked]>
Date: Sat, 29 Nov 2008 09:41:07 +1100

When the cache key discussion came up, it became clear that we needed  
to do some digging into the history of HTTP caching, which means  
looking at the mailing list of the original HTTPWG's caching sub- 
group. Unfortunately, I couldn't locate any online archives remaining,  
but Martin Hamilton kindly provided an mbox, which has been  
reconstructed at:

http://lists.w3.org/Archives/Public/http-caching-historical/

In looking through that, it's clear that there was discussion of POST  
caching, etc. early on;
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Jan/0025.html
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Jan/0026.html
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Jan/0028.html
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Jan/0030.html
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Jan/0075.html

(I believe this is before the difference between Location and Content- 
Location was specified, which is why Location is mentioned).

But, no consensus was reached, as reflected by the state of the  
"updated issues list" (under "not agreed");
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Feb/0114.html

It did come up at a F2F, but was not "fully" discussed, and several  
aspects were deferred;
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Feb/0039.html

> Issue: PUTs and POSTs
>
> There was some discussion about caching the results of POSTs,
> and/or the bodies of PUTs, as examples of how the current
> GET-only caching model could be extended.  That is, we discussed
> these as stand-ins for hypothetical future methods while discussing
> the general problem of extensibility.  We did not have time to
> fully discuss caching for PUTs and POSTs.
>
> DEFERRED ITEM: caching of responses to POSTs
>
> DEFERRED ITEM: caching and PUTs
>
> Shel added this point:
>    We have to be careful to distinguish between conditional execution
>    of a method, and conditional return of the response.  In the case
>    of GET, since it nominally has no side effects, conditional
>    execution of the method is not so important.  But if we start
>    applying conditionality to POST, PUT, etc., it is *critical* to be
>    absolutely clear about what aspect of the action and response is
>    conditional.

This appears to be where the subgroup left it. Jeff did make a  
proposal at the very end of the subgroup's lifetime:
   http://lists.w3.org/Archives/Public/http-caching-historical/1996Apr/0114.html

but this appears not to have been adopted. I don't see any relevant  
discussion on the main http-wg mailing list after this point, so my  
assumption is this is how it was left.

If any of the involved parties recall any other details, please  
provide them.

Cheers,

--
Mark Nottingham     http://www.mnot.net/